﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	
	Private lst_Appointments As List
	Private lstCollission As List
	
	Type Appointment(Id As Int,StartDate As Long,EndDate As Long,Title As String)
	Type VirtualView(Left As Double, Top As Double, Right As Double, Height As Double, Title As String)
End Sub

Public Sub Initialize
	
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("frm_main")
	'B4XPages.GetNativeParent(Me).As(Form).WindowTop=1350
	Sleep(0)

	lst_Appointments.Initialize
	lstCollission.Initialize
	
	'Not working
	lst_Appointments.Add(CreateAppointment(1,DateUtils.SetDateAndTime(2022,8,12,11,30,0),DateUtils.SetDateAndTime(2022,8,12,14,30,0),"Test1"))
	lst_Appointments.Add(CreateAppointment(3,DateUtils.SetDateAndTime(2022,8,12,11,30,0),DateUtils.SetDateAndTime(2022,8,12,12,30,0),"Test2"))
	lst_Appointments.Add(CreateAppointment(3,DateUtils.SetDateAndTime(2022,8,12,12,30,0),DateUtils.SetDateAndTime(2022,8,12,13,30,0),"Test3"))
	lst_Appointments.Add(CreateAppointment(4,DateUtils.SetDateAndTime(2022,8,12,12,0,0),DateUtils.SetDateAndTime(2022,8,12,13,15,0),"Test4"))
	lst_Appointments.Add(CreateAppointment(2,DateUtils.SetDateAndTime(2022,8,12,11,30,0),DateUtils.SetDateAndTime(2022,8,12,12,30,0),"Test5"))
	
	lst_Appointments.Add(CreateAppointment(2,DateUtils.SetDateAndTime(2022,8,12,15,00,0),DateUtils.SetDateAndTime(2022,8,12,16,00,0),"Test6"))
	lst_Appointments.Add(CreateAppointment(2,DateUtils.SetDateAndTime(2022,8,12,15,00,0),DateUtils.SetDateAndTime(2022,8,12,16,00,0),"Test7"))
	lst_Appointments.Add(CreateAppointment(2,DateUtils.SetDateAndTime(2022,8,12,16,00,0),DateUtils.SetDateAndTime(2022,8,12,17,00,0),"Test7c"))
	lst_Appointments.Add(CreateAppointment(2,DateUtils.SetDateAndTime(2022,8,12,15,00,0),DateUtils.SetDateAndTime(2022,8,12,18,00,0),"Test8"))
	lst_Appointments.Add(CreateAppointment(2,DateUtils.SetDateAndTime(2022,8,12,15,00,0),DateUtils.SetDateAndTime(2022,8,12,19,00,0),"Test9"))
	lst_Appointments.Add(CreateAppointment(2,DateUtils.SetDateAndTime(2022,8,12,18,00,0),DateUtils.SetDateAndTime(2022,8,12,19,00,0),"Test10"))
	'Working
'	lst_Appointments.Add(CreateAppointment(1,DateUtils.SetDateAndTime(2022,8,12,11,30,0),DateUtils.SetDateAndTime(2022,8,12,13,30,0),"Test1"))
'	lst_Appointments.Add(CreateAppointment(2,DateUtils.SetDateAndTime(2022,8,12,11,30,0),DateUtils.SetDateAndTime(2022,8,12,12,0,0),"Test4"))
	
	CreateAppointments
	
End Sub

Private Sub B4XPage_Resize (Width As Int, Height As Int)
	CreateAppointments
End Sub

Private Sub CreateAppointments
	Dim MaxCol As Int = 0
	Dim OneMinuteInMinute As Double = (Root.Height/48)/30
	Dim ListOfView As List
	Dim VirtualWidth As Int = 100 ' 100 arbitray ipotetic width
	Dim VirtualMaxWidth As Int = 0
	Dim RealMaxWidth As Int = Root.Width
	Dim RealWidthCol As Double
	
	lst_Appointments.SortType("StartDate",True)
	' virtual position
	ListOfView.Initialize
	For i = 0 To lst_Appointments.Size -1
		Dim Appointment As Appointment = lst_Appointments.Get(i)
		
		Dim Top As Double = OneMinuteInMinute*(DateTime.GetHour(Appointment.StartDate)*60) + OneMinuteInMinute*(DateTime.GetMinute(Appointment.StartDate))
		Dim Height As Double = (OneMinuteInMinute*(DateTime.GetHour(Appointment.EndDate)*60) + OneMinuteInMinute*(DateTime.GetMinute(Appointment.EndDate))) - Top
		Dim Vv As VirtualView = CreateVirtualView(0,Top,100,Height,Appointment.Title)

		'CheckOverlapping(i,xlbl_Appointment,Appointment)
		Do While OverlopView(Vv,ListOfView)
			Vv.left=Vv.left+VirtualWidth
			Vv.Right=Vv.Right+VirtualWidth
			VirtualMaxWidth=Max(VirtualMaxWidth,Vv.Right)
		Loop
		ListOfView.Add(Vv)
	Next
	
	' check for extend
	For Each vw As VirtualView In ListOfView
		Do While CheckExtendibleView(vw,ListOfView,VirtualWidth,VirtualMaxWidth)=False 
			vw.Right=vw.Right+VirtualWidth
		Loop
		'If CheckExtendibleView(vw,ListOfView,w,MaxWidth)=False Then vw.Width=vw.Width+w
	Next

	' Num col
	MaxCol= VirtualMaxWidth/VirtualWidth
	RealWidthCol=RealMaxWidth/MaxCol
	
	' Desgin Real View
	Root.RemoveAllViews
	For Each Vv As VirtualView In ListOfView
		Dim xlbl_Appointment As B4XView = CreateLabel("")

		xlbl_Appointment.Color = xui.Color_ARGB(255,Rnd(0,256),Rnd(0,256),Rnd(0,256))
		xlbl_Appointment.Text = Vv.Title
		xlbl_Appointment.SetTextAlignment("TOP","LEFT")
		xlbl_Appointment.TextColor = xui.Color_White
		
		Vv.Left=(Vv.Left/VirtualWidth)*RealWidthCol
		Vv.Right=(Vv.Right/VirtualWidth)*RealWidthCol
		Root.AddView(xlbl_Appointment,Vv.Left,Vv.Top,Vv.Right-Vv.Left,Vv.Height)
	Next
End Sub

Private Sub OverlopView(V As VirtualView,ListOfView As List) As Boolean
	Dim B As Boolean = False
	For Each v2 As VirtualView In ListOfView
		If ((V.Left>=v2.Left And V.Left<v2.Right) And (V.top>=v2.top And V.top<v2.top+v2.Height)) Or _
			((V.Right>v2.Left And V.Right<v2.Right) And (V.top>=v2.top And V.top<v2.top+v2.Height)) Or _
			((V.Left>=v2.Left And V.Left<v2.Right) And (V.top+V.Height>=v2.top And V.top+V.Height<v2.top+v2.Height)) Or _
			((V.Right>v2.Left And V.Right<v2.Right) And (V.top+V.Height>=v2.top And V.top+V.Height<v2.top+v2.Height)) _
			Then
			B=True
		End If
	Next
	Return b
End Sub

Private Sub CheckExtendibleView(V As VirtualView,ListOfView As List,width As Int, MaxWidth As Int) As Boolean
	Dim B As Boolean = False

	If v.Right+width>MaxWidth Then Return True
	For Each v2 As VirtualView In ListOfView
		If v2<>v Then 
			If ((V.Right>=v2.Left And V.Right<v2.Right) And (V.top>=v2.top And V.top<v2.top+v2.Height)) Or _
				((V.Right+width>v2.Left And V.Right+width<=v2.Right) And (V.top>=v2.top And V.top<v2.top+v2.Height)) Or _
				((V.Right>=v2.Left And V.Right<v2.Right) And (V.top+V.Height>v2.top And V.top+V.Height<=v2.top+v2.Height)) Or _
				((V.Right+width>v2.Left And V.Right+width<=v2.Right) And (V.top+V.Height>v2.top And V.top+V.Height<=v2.top+v2.Height)) _
				Then
				B=True
			End If
		End If
	Next
	Return b
End Sub

Private Sub CreateLabel(EventName As String) As B4XView
	Dim lbl As Label
	lbl.Initialize(EventName)
	Return lbl
End Sub

Public Sub CreateAppointment (Id As Int, StartDate As Long, EndDate As Long, Title As String) As Appointment
	Dim t1 As Appointment
	t1.Initialize
	t1.Id = Id
	t1.StartDate = StartDate
	t1.EndDate = EndDate
	t1.Title = Title
	Return t1
End Sub

Public Sub CreateVirtualView (Left As Double, Top As Double, Right As Double, Height As Double, Title As String) As VirtualView
	Dim t1 As VirtualView
	t1.Initialize
	t1.Left = Left
	t1.Top = Top
	t1.Right = Right
	t1.Height = Height
	t1.Title = Title
	Return t1
End Sub